Skip to main content Skip to footer

Using the Space Key to Select or Deselect a FlexGrid Row in React

Background:

Wijmo FlexGrid includes built-in keyboard support. By default, the Space key starts editing, toggles a checkbox cell, or expands and collapses group rows, while Shift + Space selects a row.

In some React applications, you may want the Space key by itself to select or deselect the current row. You can implement this behavior by using the React FlexGrid component's selectionChanged event, storing the initialized FlexGrid control instance in a ref, toggling the current row's isSelected property when Space is pressed, and calling the grid's refresh method so the visual selection state is updated immediately.

Steps to Complete:

  1. Install the Wijmo React Grid packages.
  2. Import React hooks, Wijmo components, grid types, and styles.
  3. Create the data and refs.
  4. Store the initialized grid instance.
  5. Track the current row with selectionChanged.
  6. Handle Space and toggle isSelected.
  7. Clean up the listener on unmount.
  8. Render the React FlexGrid.

Getting Started:

Install the Wijmo React Grid packages

npm install @mescius/wijmo.react.grid @mescius/wijmo.grid @mescius/wijmo.styles
  • The wijmo.react.grid package provides the React FlexGrid component. The wijmo.grid package provides core grid types such as FlexGrid, SelectionMode, Row, and CellRangeEventArgs.

 

Import React hooks, Wijmo components, grid types, and styles

import { useCallback, useEffect, useRef, useState } from 'react';
import * as wjcGrid from '@mescius/wijmo.react.grid';
import { CellRangeEventArgs, FlexGrid, Row, SelectionMode } from '@mescius/wijmo.grid';
import '@mescius/wijmo.styles/wijmo.css';
import './App.css';

 

Create the data and refs

Use refs for the grid and current row so event handlers can access them without re-rendering.

const [data] = useState([
  { id: 1, country: 'United States', sales: 12000, active: true },
  { id: 2, country: 'Canada', sales: 9500, active: false }
]);

const gridRef = useRef<FlexGrid | null>(null);
const currentRowRef = useRef<Row | null>(null);

 

Store the initialized grid instance

const initializeGrid = useCallback((grid: FlexGrid): void => {
  gridRef.current?.hostElement.removeEventListener('keydown', onGridKeyDown);
  gridRef.current = grid;
  grid.hostElement.addEventListener('keydown', onGridKeyDown);
}, [onGridKeyDown]);

 

Track the current row with selectionChanged

const selectionChanged = useCallback((_grid: FlexGrid, e: CellRangeEventArgs): void => {
  currentRowRef.current = e.row > -1 ? e.getRow() : null;
}, []);
  • The selectionChanged handler stores the row associated with the current grid selection in a React ref.

 

Handle Space and toggle isSelected

const onGridKeyDown = useCallback((e: KeyboardEvent): void => {
  const isSpaceKey = e.code === 'Space' || e.key === ' ';
  if (!isSpaceKey || e.ctrlKey || e.altKey || e.shiftKey || e.metaKey) return;

  const grid = gridRef.current;
  if (!grid || grid.activeEditor) return;

  const row = currentRowRef.current || grid.rows[grid.selection.row];
  if (!row) return;

  e.preventDefault();
  row.isSelected = !row.isSelected;
  grid.refresh();
}, []);
  • The keyboard handler checks for an unmodified Space key, prevents the default Space behavior, toggles row.isSelected, and calls refresh() so the row's selected appearance is updated.

 

Clean up the listener on unmount

useEffect(() => {
  return () => {
    gridRef.current?.hostElement.removeEventListener('keydown', onGridKeyDown);
  };
}, [onGridKeyDown]);
  • The useEffect cleanup removes the keyboard listener when the React component is unmounted.

 

Render the React FlexGrid

<wjcGrid.FlexGrid
  className="grid"
  itemsSource={data}
  autoGenerateColumns={false}
  selectionMode={SelectionMode.ListBox}
  initialized={initializeGrid}
  selectionChanged={selectionChanged}
>
  <wjcGrid.FlexGridColumn header="ID" binding="id" width={70} />
  <wjcGrid.FlexGridColumn header="Country" binding="country" width="*" />
  <wjcGrid.FlexGridColumn header="Sales" binding="sales" format="n0" />
  <wjcGrid.FlexGridColumn header="Active" binding="active" />
</wjcGrid.FlexGrid>
  • initialized gives the component access to the underlying FlexGrid control instance.
  • selectionChanged tracks the active row as the user navigates through the grid.
  • SelectionMode.ListBox allows rows to be selected and deselected.

 

With this setup, users can move through the React FlexGrid with the keyboard and press Space to select or deselect the active row.


Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Using the Space Key to Select or Deselect a FlexGrid Row in Angular

Background:

Wijmo FlexGrid includes built-in keyboard support. By default, the Space key starts editing, toggles a checkbox cell, or expands and collapses group rows, while Shift + Space selects a row.

In some Angular applications, you may want the Space key by itself to select or deselect the current row. You can implement this behavior by using the Angular FlexGrid component's selectionChanged event, storing the initialized WjFlexGrid instance, toggling the current row's isSelected property when Space is pressed, and calling the grid's refresh method so the visual selection state is updated immediately.

Steps to Complete:

  1. Install and import the Wijmo Angular Grid packages.
  2. Add the Wijmo stylesheet.
  3. Create the Angular FlexGrid markup.
  4. Create the grid data and selection handlers in the Angular component.
  5. Handle the Space key and toggle the row's isSelected property.

Getting Started:

Install and import the Wijmo Angular Grid packages

npm install @mescius/wijmo.angular2.grid @mescius/wijmo.grid @mescius/wijmo.styles
  • The wijmo.angular2.grid package provides the Angular FlexGrid component. The wijmo.grid package provides core grid types such as SelectionMode, Row, and CellRangeEventArgs.

 

Add the Wijmo stylesheet

In styles.css, import the Wijmo CSS file:

@import '@mescius/wijmo.styles/wijmo.css';
  • This stylesheet applies the default FlexGrid styles used by the Angular component.

 

Create the Angular FlexGrid markup

In app.component.html, declare the FlexGrid and its columns:

<wj-flex-grid
  #flex
  class="grid"
  [itemsSource]="data"
  [autoGenerateColumns]="false"
  [selectionMode]="selectionMode"
  (initialized)="initializeGrid(flex)"
  (selectionChanged)="selectionChanged($event)"
>
  <wj-flex-grid-column
    [header]="'ID'"
    [binding]="'id'"
    [width]="70"
  ></wj-flex-grid-column>
  <wj-flex-grid-column
    [header]="'Country'"
    [binding]="'country'"
    [width]="'*'"
  ></wj-flex-grid-column>
  <wj-flex-grid-column
    [header]="'Sales'"
    [binding]="'sales'"
    [format]="'n0'"
  ></wj-flex-grid-column>
  <wj-flex-grid-column
    [header]="'Active'"
    [binding]="'active'"
  ></wj-flex-grid-column>
</wj-flex-grid>
  • initialized gives the component access to the underlying WjFlexGrid instance. selectionChanged tracks the active row as the user navigates through the grid. ListBox selection mode is supplied from the component so rows can be selected and deselected.

 

Create the grid data and selection handlers in the Angular component

In app.component.ts, import the Wijmo Angular grid module and the core grid types:

import { Component, OnDestroy } from '@angular/core';
import { WjFlexGrid, WjGridModule } from '@mescius/wijmo.angular2.grid';
import { CellRangeEventArgs, Row, SelectionMode } from '@mescius/wijmo.grid';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [WjGridModule],
  templateUrl: './app.component.html',
  styleUrl: './app.component.css'
})
export class AppComponent implements OnDestroy {
  data = [
    { id: 1, country: 'United States', sales: 12000, active: true },
    { id: 2, country: 'Canada', sales: 9500, active: false },
    { id: 3, country: 'Japan', sales: 14200, active: true },
    { id: 4, country: 'Germany', sales: 10100, active: false },
    { id: 5, country: 'Brazil', sales: 8700, active: true }
  ];

  selectionMode = SelectionMode.ListBox;

  private grid: WjFlexGrid | null = null;
  private currentRow: Row | null = null;

  initializeGrid(grid: WjFlexGrid): void {
    this.grid?.hostElement.removeEventListener('keydown', this.onGridKeyDown);
    this.grid = grid;
    this.grid.hostElement.addEventListener('keydown', this.onGridKeyDown);
  }

  selectionChanged(e: CellRangeEventArgs): void {
    this.currentRow = e.row > -1 ? e.getRow() : null;
  }

  ngOnDestroy(): void {
    this.grid?.hostElement.removeEventListener('keydown', this.onGridKeyDown);
  }

  ...
  • The selectionChanged handler stores the row associated with the current grid selection.

 

Handle the Space key and toggle the row's isSelected property

private onGridKeyDown = (e: KeyboardEvent): void => {
    const isSpaceKey = e.code === 'Space' || e.key === ' ';

    if (!isSpaceKey || e.ctrlKey || e.altKey || e.shiftKey || e.metaKey) {
      return;
    }

    if (!this.grid || this.grid.activeEditor) {
      return;
    }

    const row = this.currentRow || this.grid.rows[this.grid.selection.row];

    if (!row) {
      return;
    }

    e.preventDefault();

    row.isSelected = !row.isSelected;
    this.grid.refresh();
  };
}
  • The keyboard handler checks for an unmodified Space key, prevents the default Space behavior, toggles row.isSelected, and calls refresh() so the row's selected appearance is updated. The ngOnDestroy method removes the keyboard listener when the component is destroyed.

 

With this setup, users can move through the Angular FlexGrid with the keyboard and press Space to select or deselect the active row.


Happy coding!

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Using the Space Key to Select or Deselect a FlexGrid Row in Vue

Background:

Wijmo FlexGrid includes built-in keyboard support. By default, the Space key starts editing, toggles a checkbox cell, or expands and collapses group rows, while Shift + Space selects a row.

In some Vue applications, you may want the Space key by itself to select or deselect the current row. You can implement this behavior by using the Vue FlexGrid component’s selectionChanged event, storing the initialized FlexGrid control instance in a ref, toggling the current row’s isSelected property when Space is pressed, and calling the grid’s refresh method so the visual selection state is updated immediately.

Steps to Complete:

  1. Install the Wijmo Vue Grid packages.
  2. Register the Wijmo Grid components and import the stylesheet.
  3. Import Vue APIs and Wijmo grid types.
  4. Create the grid data and refs.
  5. Store the initialized grid instance.
  6. Track the current row with selectionChanged.
  7. Handle the Space key and toggle isSelected.
  8. Remove the keyboard listener when the component unmounts.
  9. Render the Vue FlexGrid.

Getting Started:

Install the Wijmo Vue Grid packages

Install the Vue grid wrapper, the core grid package, and the Wijmo stylesheet package.

npm install @mescius/wijmo.vue2.grid @mescius/wijmo.grid @mescius/wijmo.styles

 

Register the Wijmo Grid components and import the stylesheet

Register the grid module once in the Vue application entry file so <wj-flex-grid> and <wj-flex-grid-column> can be used in Vue templates.

import { createApp } from 'vue';
import { registerGrid } from '@mescius/wijmo.vue2.grid';
import '@mescius/wijmo.styles/wijmo.css';
import App from './App.vue';

const app = createApp(App);
registerGrid(app);
app.mount('#app');

 

Import Vue APIs and Wijmo grid types

Use Vue Composition API helpers for state and cleanup. Use core grid types for the FlexGrid instance, selected row, event arguments, and selection mode.

<script setup lang="ts">
import { onBeforeUnmount, ref, shallowRef } from 'vue';
import { CellRangeEventArgs, FlexGrid, Row, SelectionMode } from '@mescius/wijmo.grid';
</script>

 

Create the grid data and refs

Store the data in a Vue ref. Store the grid instance and current row in shallowRef values because these hold external Wijmo objects and do not need deep Vue reactivity.

const data = ref([
  { id: 1, country: 'United States', sales: 12000, active: true },
  { id: 2, country: 'Canada', sales: 9500, active: false },
  { id: 3, country: 'Japan', sales: 14200, active: true },
  { id: 4, country: 'Germany', sales: 10100, active: false },
  { id: 5, country: 'Brazil', sales: 8700, active: true }
]);

const gridRef = shallowRef<FlexGrid | null>(null);
const currentRowRef = shallowRef<Row | null>(null);

 

Store the initialized grid instance

The initialized event gives access to the underlying FlexGrid control. Store that control in a ref and attach the keyboard listener to the grid host element.

function initializeGrid(grid: FlexGrid): void {
  gridRef.value?.hostElement.removeEventListener('keydown', onGridKeyDown);
  gridRef.value = grid;
  grid.hostElement.addEventListener('keydown', onGridKeyDown);
}

 

Track the current row with selectionChanged

When the active selection changes, store the selected row. This gives the Space key handler a row to select or deselect.

function selectionChanged(_grid: FlexGrid, e: CellRangeEventArgs): void {
  currentRowRef.value = e.row > -1 ? e.getRow() : null;
}

 

Handle the Space key and toggle isSelected

Check for an unmodified Space key, skip the logic when a cell editor is active, toggle the row’s isSelected value, and refresh the grid so the selected state is shown immediately.

function onGridKeyDown(e: KeyboardEvent): void {
  const isSpaceKey = e.code === 'Space' || e.key === ' ';

  if (!isSpaceKey || e.ctrlKey || e.altKey || e.shiftKey || e.metaKey) {
    return;
  }

  const grid = gridRef.value;

  if (!grid || grid.activeEditor) {
    return;
  }

  const row = currentRowRef.value || grid.rows[grid.selection.row];

  if (!row) {
    return;
  }

  e.preventDefault();

  row.isSelected = !row.isSelected;
  grid.refresh();
}

 

Remove the keyboard listener when the component unmounts

Cleaning up the listener prevents duplicate handlers if the component is removed and mounted again.

onBeforeUnmount(() => {
  gridRef.value?.hostElement.removeEventListener('keydown', onGridKeyDown);
});

 

Render the Vue FlexGrid

Set selectionMode to SelectionMode.ListBox so rows can be selected and deselected. Bind the initialized and selectionChanged events to the handlers created above.

<template>
  <wj-flex-grid
    class="grid"
    :itemsSource="data"
    :autoGenerateColumns="false"
    :selectionMode="SelectionMode.ListBox"
    :initialized="initializeGrid"
    :selectionChanged="selectionChanged"
  >
    <wj-flex-grid-column header="ID" binding="id" :width="70" />
    <wj-flex-grid-column header="Country" binding="country" width="*" />
    <wj-flex-grid-column header="Sales" binding="sales" format="n0" />
    <wj-flex-grid-column header="Active" binding="active" />
  </wj-flex-grid>
</template>

 

With this setup, users can move through the Vue FlexGrid with the keyboard and press Space to select or deselect the active row.

Happy coding!

Andrew Peterson

Technical Engagement Engineer